<template>
  <div class="gpa-activity">
    <rui-icon :name="icon" />
    <span class="gpa-activity__text" :class="cssClass">{{ message }}</span>
  </div>
</template>

<script>
import RuiIcon from '@experiments-labs/rise_ui/src/components/Icon/Icon.vue'

import Activity from '../../../../classes/models/Activity'
import ActivityConfiguration from './ActivityConfiguration'

export default {
  name: 'GpaActivity',
  components: { RuiIcon },
  props: {
    activity: { required: true, type: Activity },
  },
  data () {
    return {
      icon: null,
      message: null,
      cssClass: null,
    }
  },
  methods: {
    setData () {
      let cssClass = 'text--color-mute'
      let icon = 'question'
      let message = this.$t('js.activity.unknown_action', { subject: this.$props.activity.subjectType, action: this.$props.activity.action })

      if (ActivityConfiguration[this.$props.activity.subjectType] && ActivityConfiguration[this.$props.activity.subjectType][this.$props.activity.action]) {
        const options = ActivityConfiguration[this.$props.activity.subjectType][this.$props.activity.action]
        cssClass = options.cssClass || cssClass
        icon = options.icon
        message = options.message(this)
      }

      this.cssClass = cssClass
      this.icon = icon
      this.message = message
    },
  },
  created () {
    this.setData()
  },
}
</script>

<style lang="scss" src="./Activity.scss" />
